Index: trunk/source/App/TAppDecoder/TAppDecTop.cpp
===================================================================
--- trunk/source/App/TAppDecoder/TAppDecTop.cpp	(revision 1314)
+++ trunk/source/App/TAppDecoder/TAppDecTop.cpp	(revision 1321)
@@ -1076,7 +2649,11 @@
     m_tDecTop[ decIdx ]->setLayerId( layerId );
     m_tDecTop[ decIdx ]->setDecodedPictureHashSEIEnabled(m_decodedPictureHashSEIEnabled);
-    m_tDecTop[ decIdx ]->setIvPicLists( &m_ivPicLists ); 
-    m_tDecTop[ decIdx ]->setLayerInitilizedFlags( m_layerInitilizedFlags );
-    m_tDecTop[ decIdx ]->setTargetOlsIdx( m_targetOptLayerSetIdx );    
+    m_tDecTop[ decIdx ]->setDpb( &m_dpb );
+    m_tDecTop[ decIdx ]->setTargetOlsIdx( m_targetOptLayerSetIdx );
+    m_tDecTop[ decIdx ]->setFirstPicInLayerDecodedFlag( m_firstPicInLayerDecodedFlag );
+    m_tDecTop[ decIdx ]->setPocDecrementedInDPBFlag   ( m_pocDecrementedInDpbFlag    );
+    m_tDecTop[ decIdx ]->setLastPresentPocResetIdc    ( m_lastPresentPocResetIdc );
+
+
 #if O0043_BEST_EFFORT_DECODING
     m_cTDecTop[ decIdx ]->setForceDecodeBitDepth(m_forceDecodeBitDepth);
@@ -1091,29 +2668,26 @@
 #endif
 
-    // append pic list of new decoder to PicLists 
-    assert( m_ivPicLists.size() == m_numDecoders );
-    m_ivPicLists.push_back( m_tDecTop[ decIdx ]->getListPic() );
-
-    // create recon file related stuff      
+    // append pic list of new decoder to PicLists
+
+    // create recon file related stuff
     Char* pchTempFilename = NULL;
     if ( m_pchReconFile )
-    {      
-      Char buffer[4];      
+    {
+      Char buffer[4];
       sprintf(buffer,"_%i", layerId );
-      assert ( m_pchReconFile ); 
+      assert ( m_pchReconFile );
       xAppendToFileNameEnd( m_pchReconFile , buffer, pchTempFilename );
       assert( m_pchReconFiles.size() == m_numDecoders );
     }
 
-    m_pchReconFiles.push_back( pchTempFilename );   
+    m_pchReconFiles.push_back( pchTempFilename );
 
     m_tVideoIOYuvReconFile[ decIdx ] = new TVideoIOYuv;
     m_reconOpen           [ decIdx ] = false;
 
-    // set others 
-    m_pocLastDisplay      [ decIdx ] = -MAX_INT;
-    m_layerIdToDecIdx     [ layerId ] = decIdx; 
-
-    m_numDecoders++; 
+    // set others
+    m_layerIdToDecIdx     [ layerId ] = decIdx;
+
+    m_numDecoders++;
   };
   return decIdx;
@@ -1121,88 +2695,313 @@
 }
 
-Void TAppDecTop::xMarkForOutput( Bool allLayersDecoded, Int pocLastPic, Int layerIdLastPic )
+Int TAppDecTop::xPreDecodePoc( InputNALUnit& nalu )
 {  
-  vector<Int> targetOptLayerIdList = m_vps->getTargetOptLayerIdList( m_targetOptLayerSetIdx );
-
-  if (m_vps->getAltOutputLayerFlagVar( m_targetOptLayerSetIdx ) )
-  {
-    assert( targetOptLayerIdList.size() == 1 ); 
-    Int targetLayerId = targetOptLayerIdList[0];     
-
-    TComPic* curPic = m_ivPicLists.getPic( layerIdLastPic, pocLastPic );
-    assert( curPic != NULL );
-
-    if ( layerIdLastPic == targetLayerId )
-    {
-      if ( curPic->getPicOutputFlag() )
-      {
-        curPic->setOutputMark( true );
+  // - According to F.7.4.2.4.4, the POC of the current picture is required to detect whether it is the first in a new AU
+  // - F.8.1.3 needs to know if the current picture is the first of an AU
+  //   actually before its POC has been decoded.
+
+  // Thus, in the software implementation the processes can not be invoked in the same order as in the Spec.
+  // For this, this function decodes the POC before invoking F.8.1.3. However, this is done without
+  // altering member variables
+
+  // Do some stuff from F.8.1.3 required for POC derivation, which is not depending on AU detection.
+  TDecTop* dec          = xGetDecoder( nalu ); 
+  TComSlice* slicePilot = dec->getSlicePilot(); 
+  Int nuhLayerId        = nalu.m_nuhLayerId; 
+  Int smallestLayerId   = dec->getSmallestLayerId();
+
+  Int handleCraAsBlaFlag; 
+  if ( nalu.isIrap() )
+  {
+    if ( !m_handleCraAsBlaFlagSetByExtMeans )
+    {
+      handleCraAsBlaFlag = false;
+    }
+  }
+
+  Bool firstPicInLayerDecodedFlag = m_firstPicInLayerDecodedFlag[ nalu.m_nuhLayerId ];
+  
+  if ( nalu.isIrap() && nuhLayerId == smallestLayerId )
+  {
+    Int noClrasOutputFlag;
+    if( m_firstSliceInBitstream )
+    {
+      noClrasOutputFlag = true; 
+    }
+    else if( m_eosInLayer[ 0 ] || m_eosInLayer[ nuhLayerId ] )
+    {
+      noClrasOutputFlag = true;
+    }
+    else if ( nalu.isBla() || (nalu.isCra() && handleCraAsBlaFlag ))
+    {
+      noClrasOutputFlag = true; 
+    }
+    else if ( nalu.isIdr() && slicePilot->getCrossLayerBlaFlag() )
+    {
+      noClrasOutputFlag = true; 
+    }
+    else if ( m_noClrasOutputFlagSetByExtMeans )
+    {
+      noClrasOutputFlag = m_noClrasOutputFlag; 
+    }
+    else
+    {     
+      noClrasOutputFlag  = false;
+    }
+
+    if( noClrasOutputFlag )
+    {
+      firstPicInLayerDecodedFlag = false; 
+    }    
+  }
+
+  // Derive POC
+  return dec->preDecodePoc(firstPicInLayerDecodedFlag, m_newPicIsFstPicOfAllLayOfPocResetPer, m_newPicIsPocResettingPic );
+}
+
+Bool TAppDecTop::xDetectNewAu( InputNALUnit& nalu )
+{
+  TDecTop*        dec        = xGetDecoder( nalu );
+  TComSlice*      slicePilot = dec->getSlicePilot();
+  const TComVPS*  vps        = slicePilot->getVPS();
+
+  Bool firstVclNaluOfAu;
+
+  if (m_curPic == NULL )
+  {
+    // No picture decoded yet, so we have a new AU.
+    firstVclNaluOfAu = true; 
+  }
+  else
+  {
+    if ( !vps->getVpsExtensionFlag() )
+    {
+      // Decoding according to clause 8, hence one pic per AU.
+      firstVclNaluOfAu = slicePilot->getFirstSliceSegementInPicFlag();
+    }
+    else
+    {
+      if ( dec->getTargetOlsIdx() == 0 )
+      {
+        // Only the base layer is decoded, hence one pic per AU.
+        firstVclNaluOfAu = slicePilot->getFirstSliceSegementInPicFlag();
       }
       else
-      {        
-        xMarkAltOutPic( targetLayerId, pocLastPic ); 
-      }
-      m_markedForOutput = true; 
-    }
-    else if ( ( layerIdLastPic > targetLayerId || allLayersDecoded ) && !m_markedForOutput )
-    {
-      xMarkAltOutPic( targetLayerId, pocLastPic );
-    }
-
-    if ( allLayersDecoded )
-    {
-      m_markedForOutput = false; 
-    }
+      {
+        // F.7.4.2.4.4  Order of NAL units and coded pictures and association to access units    
+        //  An access unit consists of one or more coded pictures, each with a distinct value of 
+        //  nuh_layer_id, and zero or more non-VCL NAL units. 
+
+        //  A VCL NAL unit is the first VCL NAL unit of an access unit, when all of the following conditions are true:
+        //  -  first_slice_segment_in_pic_flag is equal to 1.
+        //  -  At least one of the following conditions is true:
+        //     - The previous picture in decoding order belongs to a different POC resetting period 
+        //       than the picture containing the VCL NAL unit.
+        Bool prevPicDiffPocResetPeriod = m_newPicIsFstPicOfAllLayOfPocResetPer; 
+
+        //     - PicOrderCntVal derived for the VCL NAL unit differs from the PicOrderCntVal of the 
+        //       previous picture in decoding order.
+        Bool prevPicDiffPoc = ( xPreDecodePoc( nalu ) != m_curPic->getPOC() );
+
+        if( slicePilot->getFirstSliceSegementInPicFlag() && ( prevPicDiffPocResetPeriod || prevPicDiffPoc ) )
+        {
+          firstVclNaluOfAu = true;
+        }
+        else
+        {
+          firstVclNaluOfAu = false;
+        }
+      }
+    }
+  }
+  return firstVclNaluOfAu;
+}
+
+Void TAppDecTop::xDetectNewPocResettingPeriod( InputNALUnit& nalu )
+{
+  TDecTop* dec  = xGetDecoder( nalu );
+  dec->inferPocResetPeriodId();
+
+
+  Int pocResetIdc         = dec->getSlicePilot()->getPocResetIdc();
+  Int newPocResetPeriodId = dec->getSlicePilot()->getPocResetPeriodId();
+
+  Int curPocResetPeriodId = ( m_curPic != NULL)  ? m_curPic->getPocResetPeriodId() : MIN_INT; 
+
+  // Check if new picture starts a new poc resetting period.
+  if(  ( pocResetIdc == 1 || pocResetIdc == 2 ) &&  ( curPocResetPeriodId != newPocResetPeriodId ) )
+  {
+    for (Int i = 0; i < MAX_NUM_LAYER_IDS; i++ )
+    {
+      m_firstPicInPocResettingPeriodReceived[ i ] = false;
+    }
+    m_newPicIsFstPicOfAllLayOfPocResetPer = true;
   }
   else
-  { 
-    for( Int dI = 0; dI < m_numDecoders; dI++ )
-    {      
-      Int layerId = m_tDecTop[dI]->getLayerId(); 
-      TComPic* curPic = m_ivPicLists.getPic( layerId, pocLastPic );
-      if ( curPic != NULL )
-      {
-        if ( curPic->getReconMark() )
-        {
-          Bool isTargetOptLayer = std::find(targetOptLayerIdList.begin(), targetOptLayerIdList.end(), layerId) != targetOptLayerIdList.end();
-          curPic->setOutputMark( isTargetOptLayer ? curPic->getPicOutputFlag() : false ); 
-        }
-      }
-    }
-  }
-}
-
-Void TAppDecTop::xMarkAltOutPic( Int targetOutputLayer, Int pocLastPic )
-{
-  Int optLayerIdxInVps = m_vps->getLayerIdInNuh( targetOutputLayer ); 
-  Int highestNuhLayerId = -1; 
-  TComPic* picWithHighestNuhLayerId = NULL; 
-  for (Int dIdx = 0; dIdx < m_numDecoders; dIdx++)
-  {
-    Int curLayerId = m_tDecTop[dIdx]->getLayerId();
-    Int curLayerIdxInVps = m_vps->getLayerIdInNuh( curLayerId  ); 
-    if ( m_vps->getDependencyFlag(optLayerIdxInVps, curLayerIdxInVps ) )
-    {
-      TComPic* curPic = m_ivPicLists.getPic( curLayerId, pocLastPic ); 
-      if (curPic != NULL)
-      {
-        if (curPic->getReconMark() && curPic->getPicOutputFlag() )
-        {
-          curPic->setOutputMark   ( false ); 
-          curPic->setPicOutputFlag( false ); 
-          if ( curLayerId > highestNuhLayerId)
-          {
-            highestNuhLayerId = curLayerId ; 
-            picWithHighestNuhLayerId = curPic; 
-          }            
-        }
-      }
-    }
-  }
-  if ( picWithHighestNuhLayerId != NULL )
-  {
-    picWithHighestNuhLayerId->setPicOutputFlag(true); 
-    picWithHighestNuhLayerId->setOutputMark   (true); 
-  }
+  {
+    m_newPicIsFstPicOfAllLayOfPocResetPer = false;
+  }
+
+  // Check if current picture is a poc resetting picture (thus the first picture of this layer within the POC resetting period.
+  if ( !m_firstPicInPocResettingPeriodReceived[ nalu.m_nuhLayerId ] )
+  {
+    m_newPicIsPocResettingPic = true;
+    m_firstPicInPocResettingPeriodReceived[ nalu.m_nuhLayerId ] = true;
+  }
+  else
+  {
+    m_newPicIsPocResettingPic = false;
+  }
+
+}
+
+Bool TAppDecTop::xAllRefLayersInitilized( Int curLayerId )
+{
+  Bool allRefLayersInitilizedFlag = true;
+  for (Int i = 0; i < m_vps->getNumDirectRefLayers( curLayerId  ); i++ )
+  {
+    Int refLayerId = m_vps->getIdDirectRefLayer( curLayerId, i );
+    allRefLayersInitilizedFlag = allRefLayersInitilizedFlag && m_layerInitilizedFlag[ refLayerId ];
+  }
+
+  return allRefLayersInitilizedFlag;
+}
+
+Void TAppDecTop::xInitFileIO()
+{
+  m_bitstreamFile.open(m_pchBitstreamFile, ifstream::in | ifstream::binary);
+
+  if ( !m_bitstreamFile)
+  {
+    fprintf(stderr, "\nUnable to open bitstream file `%s' for reading\n", m_pchBitstreamFile);
+    exit(EXIT_FAILURE);
+  }
+
+  if (!m_outputDecodedSEIMessagesFilename.empty() && m_outputDecodedSEIMessagesFilename!="-")
+  {
+    m_seiMessageFileStream.open(m_outputDecodedSEIMessagesFilename.c_str(), std::ios::out);
+    if (!m_seiMessageFileStream.is_open() || !m_seiMessageFileStream.good())
+    {
+      fprintf(stderr, "\nUnable to open file `%s' for writing decoded SEI messages\n", m_outputDecodedSEIMessagesFilename.c_str());
+      exit(EXIT_FAILURE);
+    }
+  }
+
+#if NH_3D
+  if( m_pchScaleOffsetFile )
+  {
+    m_pScaleOffsetFile = ::fopen( m_pchScaleOffsetFile, "wt" );
+    if (!m_pScaleOffsetFile)
+    {
+      fprintf(stderr, "\nUnable to open file `%s' for writing decoded Camera Parameters messages\n", m_pchScaleOffsetFile);
+      exit(EXIT_FAILURE);
+    }
+  }
+#endif
+}
+
+Void TAppDecTop::xOpenReconFile( TComPic* curPic )
+{
+  Int decIdx = xGetDecoderIdx( curPic->getLayerId() );
+
+  if ( m_pchReconFile && !m_reconOpen[decIdx] )
+  {
+    const BitDepths &bitDepths= curPic->getPicSym()->getSPS().getBitDepths(); // use bit depths of first reconstructed picture.
+    for (UInt channelType = 0; channelType < MAX_NUM_CHANNEL_TYPE; channelType++)
+    {
+      if (m_outputBitDepth[channelType] == 0)
+      {
+        m_outputBitDepth[channelType] = bitDepths.recon[channelType];
+      }
+    }
+
+    m_tVideoIOYuvReconFile[decIdx]->open( m_pchReconFiles[decIdx], true, m_outputBitDepth, m_outputBitDepth, bitDepths.recon ); // write mode
+    m_reconOpen[decIdx] = true;
+  }
+}
+
+Void TAppDecTop::xFlushOutput()
+{
+  Bool repeat = true;
+  while ( repeat )
+  {
+    if( m_decProcCvsg == ANNEX_F )
+    {
+      TComList<TComAu*> aus = m_dpb.getAusHavingPicsMarkedForOutput();
+      if ( !aus.empty() )
+      {
+        xF13524Bumping( aus );
+      }      
+      else
+      {
+        repeat = false;
+      }
+    }      
+    else if( m_decProcCvsg == CLAUSE_8 )
+    {
+      TComList<TComPic*> picsMarkedForOutput = m_dpb.getSubDpb( 0, false )->getPicsMarkedNeedForOutput();
+      if (!picsMarkedForOutput.empty())
+      {
+        xC524Bumping();
+      }
+      else
+      {
+        repeat = false; 
+      }
+    }
+  }
+}
+
+Void TAppDecTop::xCropAndOutput( TComPic* curPic )
+{
+
+  if ( m_printPicOutput )
+  {
+    std::cout << "  Output picture: ";
+    curPic->print( 2 );
+    std::cout << std::endl;
+  }
+
+  assert( !curPic->getHasGeneratedRefPics() );
+  assert( !curPic->getIsGenerated()         );
+
+  Int decIdx = xGetDecoderIdx( curPic->getLayerId() );
+
+  if (!m_reconOpen[ decIdx ])
+  {
+    xOpenReconFile( curPic );
+  }
+
+  if ( m_pchReconFiles[ decIdx ] )
+  {
+    const Window &conf    = curPic->getConformanceWindow();
+    const Window  defDisp = m_respectDefDispWindow ? curPic->getDefDisplayWindow() : Window();
+
+    assert( conf   .getScaledFlag() );
+    assert( defDisp.getScaledFlag() );
+
+    m_tVideoIOYuvReconFile[decIdx]->write( curPic->getPicYuvRec(),
+      m_outputColourSpaceConvert,
+      conf.getWindowLeftOffset()   + defDisp.getWindowLeftOffset(),
+      conf.getWindowRightOffset()  + defDisp.getWindowRightOffset(),
+      conf.getWindowTopOffset()    + defDisp.getWindowTopOffset(),
+      conf.getWindowBottomOffset() + defDisp.getWindowBottomOffset(),
+#if NH_3D
+      m_depth420OutputFlag && curPic->getIsDepth() ? CHROMA_420 : NUM_CHROMA_FORMAT
+#else
+      NUM_CHROMA_FORMAT
+#endif
+      , m_bClipOutputVideoToRec709Range);
+  }
+}
+
+UInt TAppDecTop::getNumberOfChecksumErrorsDetected() const
+{
+  UInt numOfChecksumErrors = 0;
+  for (Int i = 0; i < m_numDecoders; i++ )
+  {
+    numOfChecksumErrors += getNumberOfChecksumErrorsDetected( i );
+  }
+  return numOfChecksumErrors;
 }
 
Index: trunk/source/App/TAppDecoder/TAppDecTop.h
===================================================================
--- trunk/source/App/TAppDecoder/TAppDecTop.h	(revision 1314)
+++ trunk/source/App/TAppDecoder/TAppDecTop.h	(revision 1321)
@@ -60,31 +60,72 @@
 {
 private:
-  // class interface
+  // class interface  
 #if NH_MV
   TDecTop*                        m_tDecTop             [ MAX_NUM_LAYERS ];    ///< decoder classes
   TVideoIOYuv*                    m_tVideoIOYuvReconFile[ MAX_NUM_LAYERS ];    ///< reconstruction YUV class
-  Int                             m_layerIdToDecIdx     [ MAX_NUM_LAYER_IDS ]; ///< maping from layer id to decoder index
+  Int                             m_layerIdToDecIdx     [ MAX_NUM_LAYER_IDS ]; ///< mapping from layer id to decoder index
   Int                             m_numDecoders;                               ///< number of decoder instances
-  TComPicLists                    m_ivPicLists;                                ///< picture buffers of decoder instances
-  Bool                            m_layerInitilizedFlags[ MAX_NUM_LAYER_IDS ]; ///< for layerwise startup 
+  TComPicLists                    m_dpb;                                       ///< picture buffers of decoder instances
+
+  TComPic*                        m_curPic;                                    ///< currently decoded picture
+  TComAu                          m_curAu;                                     ///< currently decoded Au
+ 
+  // Random access related 
+  Bool                            m_handleCraAsBlaFlag; 
+  Bool                            m_handleCraAsBlaFlagSetByExtMeans; 
+  Bool                            m_noClrasOutputFlag; 
+  Bool                            m_noClrasOutputFlagSetByExtMeans; 
+  Bool                            m_noRaslOutputFlagAssocIrap           [ MAX_NUM_LAYER_IDS ]; 
+
+  // Layer wise startup
+  Bool                            m_firstPicInLayerDecodedFlag          [ MAX_NUM_LAYER_IDS ];
+  Bool                            m_layerInitilizedFlag                 [ MAX_NUM_LAYER_IDS ]; 
+  Bool                            m_layerResetFlag; 
+
+  // DPB related variables
+  Int                             m_maxNumReorderPics; 
+  Int                             m_maxLatencyIncreasePlus1; 
+  Int                             m_maxLatencyValue; 
+  Int                             m_maxDecPicBufferingMinus1            [ MAX_NUM_LAYER_IDS ];
+
+  // Poc resetting
+  Int                             m_lastPresentPocResetIdc              [ MAX_NUM_LAYER_IDS ];
+  Bool                            m_firstPicInPocResettingPeriodReceived[ MAX_NUM_LAYER_IDS ];
+  Bool                            m_pocDecrementedInDpbFlag             [ MAX_NUM_LAYER_IDS ]; 
+  Bool                            m_newPicIsFstPicOfAllLayOfPocResetPer;
+  Bool                            m_newPicIsPocResettingPic;
+
+  // General decoding state
+  Bool                            m_newVpsActivatedbyCurAu; 
+  Bool                            m_newVpsActivatedbyCurPic; 
+  Bool                            m_eosInLayer                          [ MAX_NUM_LAYER_IDS ];
+  Bool                            m_initilizedFromVPS;
+  Bool                            m_firstSliceInBitstream;
+  UInt64                          m_decodingOrder                       [ MAX_NUM_LAYER_IDS ];
+  UInt64                          m_totalNumofPicsReceived;
+  Bool                            m_cvsStartFound; 
+  Int                             m_smallestLayerId;
+
+  // Decoding processes for current  picture
+  DecodingProcess                 m_decProcPocAndRps;
+  DecodingProcess                 m_decProcCvsg; 
+  
+  // Active parameter sets
+  const TComPPS*                  m_pps;                                ///< active PPS
+  const TComSPS*                  m_sps;                                ///< active SPS
   const TComVPS*                  m_vps;                                ///< active VPS
+
+  Bool                            m_reconOpen           [ MAX_NUM_LAYERS ]; ///< reconstruction file opened
+#if NH_3D
+  FILE*                           m_pScaleOffsetFile;
+  CamParsCollector                m_cCamParsCollector;
+#endif
 #else
   TDecTop                         m_cTDecTop;                     ///< decoder class
   TVideoIOYuv                     m_cTVideoIOYuvReconFile;        ///< reconstruction YUV class
-#endif
   // for output control
-#if NH_MV
-  Int                             m_pocLastDisplay      [ MAX_NUM_LAYERS ]; ///< last POC in display order
-  Bool                            m_reconOpen           [ MAX_NUM_LAYERS ]; ///< reconstruction file opened
-  Bool                            m_markedForOutput; 
-#else
   Int                             m_iPOCLastDisplay;              ///< last POC in display order
 #endif
-  std::ofstream                   m_seiMessageFileStream;         ///< Used for outputing SEI messages.
-
-#if NH_3D
-  FILE*                           m_pScaleOffsetFile;
-  CamParsCollector                m_cCamParsCollector;
-#endif
+  std::ofstream                   m_seiMessageFileStream;         ///< Used for outputing SEI messages.  
 public:
   TAppDecTop();
@@ -95,16 +136,6 @@
   Void  decode            (); ///< main decoding function
 #if NH_MV
-  UInt  getNumberOfChecksumErrorsDetected( ) const 
-  {
-    UInt numOfChecksumErrors = 0; 
-    for (Int i = 0; i < m_numDecoders; i++ )
-    {
-      numOfChecksumErrors += getNumberOfChecksumErrorsDetected( i ); 
-    }
-    return numOfChecksumErrors; 
-  }
-
+  UInt  getNumberOfChecksumErrorsDetected( ) const;
   UInt  getNumberOfChecksumErrorsDetected( Int decIdx ) const { return m_tDecTop[decIdx]->getNumberOfChecksumErrorsDetected(); }
-
 #else
   UInt  getNumberOfChecksumErrorsDetected() const { return m_cTDecTop.getNumberOfChecksumErrorsDetected(); }
@@ -112,21 +143,67 @@
 
 protected:
+
   Void  xCreateDecLib     (); ///< create internal classes
   Void  xDestroyDecLib    (); ///< destroy internal classes
   Void  xInitDecLib       (); ///< initialize decoder class
 
-#if NH_MV
-  Void  xWriteOutput      ( TComList<TComPic*>* pcListPic, Int layerId, Int tId ); ///< write YUV to file
-
-  Void  xMarkForOutput   ( Bool allLayersDecoded, Int pocLastPic, Int layerIdLastPic );         
-  Void  xMarkAltOutPic    ( Int targetOutputLayer, Int pocLastPic );
-
-  Void  xFlushOutput      ( TComList<TComPic*>* pcListPic, Int layerId ); ///< flush all remaining decoded pictures to file
-  Int   xGetDecoderIdx    ( Int layerId, Bool createFlag = false );
-#else
+#if !NH_MV
   Void  xWriteOutput      ( TComList<TComPic*>* pcListPic , UInt tId); ///< write YUV to file
   Void  xFlushOutput      ( TComList<TComPic*>* pcListPic ); ///< flush all remaining decoded pictures to file
-#endif
-  Bool  isNaluWithinTargetDecLayerIdSet ( InputNALUnit* nalu ); ///< check whether given Nalu is within targetDecLayerIdSet
+  Bool  isNaluWithinTargetDecLayerIdSet    ( InputNALUnit* nalu ); ///< check whether given Nalu is within targetDecLayerIdSet
+
+#else
+  // Process NAL units 
+  Bool xExtractAndRewrite                  ( InputNALUnit* nalu );
+  Void xProcessVclNalu                     ( InputNALUnit nalu );
+  Bool xIsSkipVclNalu                      ( InputNALUnit& nalu, Bool isFirstSliceOfPic );
+  Void xProcessNonVclNalu                  ( InputNALUnit nalu );
+  Void xTerminateDecoding                  ( );
+
+  // Process slice 
+  Void xDecodeFirstSliceOfPicture          ( InputNALUnit nalu, Bool sliceIsFirstOfNewAu );  
+  Void xDecodeFollowSliceOfPicture         ( InputNALUnit nalu );
+
+  // Process picture  
+  Void xFinalizePreviousPictures           ( Bool sliceIsFirstOfNewAU );
+  Void xFinalizePic                        ( Bool curPicIsLastInAu );
+  Void xFinalizeAU                         ( );
+  Void xPicDecoding                        ( DecProcPart curPart, Bool picPosInAuIndication ); 
+
+  // Clause 8
+  Void x812CvsgDecodingProcess             ( Int decIdx );
+  Void x813decProcForCodPicWithLIdZero     ( DecProcPart curPart );
+
+  // Annex C (DPB)
+  Void xC522OutputAndRemOfPicsFromDpb      ( );
+  Void xC523PicDecMarkAddBumpAndStor       ( );
+  Void xC524Bumping                        ( );
+
+  // Annex F.8
+  Void xF811GeneralDecProc                 ( InputNALUnit nalu );
+  Void xF812CvsgDecodingProcess            ( Int decIdx );
+  Void xF813ComDecProcForACodedPic         ( DecProcPart curPart, Bool picPosInAuIndication );
+  Void xF814decProcForCodPicWithLIdZero    ( DecProcPart curPart );
+  Void xF816decProcEndDecOfCodPicLIdGrtZero( );
+
+  // Annex F.13 (DPB)
+  Void xF13521InitDpb                      ( );
+  Void xF13522OutputAndRemOfPicsFromDpb    ( Bool beforePocDerivation );
+  Void xF13523PicDecMarkAddBumpAndStor     ( Bool curPicIsLastInAu   );
+  Void xF13524Bumping                      ( TComList<TComAu*> aus );
+
+  // Helpers
+  TDecTop* xGetDecoder                     ( InputNALUnit& nalu );  
+  Int   xGetDecoderIdx                     ( Int layerId, Bool createFlag = false );
+  Int   xPreDecodePoc                      ( InputNALUnit& nalu );
+  Bool  xDetectNewAu                       ( InputNALUnit& nalu );
+  Void  xDetectNewPocResettingPeriod       ( InputNALUnit& nalu );
+  Bool  xIsNaluInTargetDecLayerIdSet       ( InputNALUnit* nalu ); ///< check whether given Nalu is within targetDecLayerIdSet
+  Bool  xAllRefLayersInitilized            ( Int curLayerId );
+  Void  xInitFileIO                        ( );  
+  Void  xOpenReconFile                     ( TComPic* curPic );
+  Void  xFlushOutput                       ( );
+  Void  xCropAndOutput                     ( TComPic* curPic );  
+#endif
 };
 
@@ -134,3 +211,2 @@
 
 #endif
-
Index: trunk/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- trunk/source/App/TAppEncoder/TAppEncTop.cpp	(revision 1314)
+++ trunk/source/App/TAppEncoder/TAppEncTop.cpp	(revision 1321)
@@ -260,8 +260,16 @@
   {
     m_cListPicYuvRec            .push_back(new TComList<TComPicYuv*>) ;
+
+#if !NH_MV
     m_ivPicLists.push_back( m_acTEncTopList[ layerIdInVps ]->getListPic()  ); 
+#endif
+
     TEncTop& m_cTEncTop = *m_acTEncTopList[ layerIdInVps ];  // It is not a member, but this name helps avoiding code duplication !!!
 
-    Int layerId = vps.getLayerIdInNuh( layerIdInVps );
+    Int layerId = vps.getLayerIdInNuh          ( layerIdInVps );
+#if NH_MV
+    m_ivPicLists.getSubDpb( layerId, true ); 
+#endif
+
     m_cTEncTop.setLayerIdInVps                 ( layerIdInVps ); 
     m_cTEncTop.setLayerId                      ( layerId );    
@@ -1216,5 +1224,5 @@
   }
 #if NH_MV
-    }
+}
   }
 #endif  
@@ -1766,5 +1774,5 @@
       // check if all inter layer reference pictures specified in the gop entry are valid reference layer pictures when allRefLayerActiveFlag is equal to 1 
       // (Should actually always be true) 
-      Bool maxTidIlRefAndSubLayerMaxVaildFlag = true; 
+      Bool maxTidIlRefAndSubLayerMaxValidFlag = true; 
       for( Int l = 0; l < ge.m_numActiveRefLayerPics; l++ )
       {   
@@ -1784,7 +1792,7 @@
           }          
         }
-       maxTidIlRefAndSubLayerMaxVaildFlag = maxTidIlRefAndSubLayerMaxVaildFlag && referenceLayerFoundFlag;  
-      }
-      assert ( maxTidIlRefAndSubLayerMaxVaildFlag ); // Something wrong with MaxTidIlRefPicsPlus1 or SubLayersVpsMaxMinus1
+       maxTidIlRefAndSubLayerMaxValidFlag = maxTidIlRefAndSubLayerMaxValidFlag && referenceLayerFoundFlag;  
+      }
+      assert ( maxTidIlRefAndSubLayerMaxValidFlag ); // Something wrong with MaxTidIlRefPicsPlus1 or SubLayersVpsMaxMinus1
     }            
   }
Index: trunk/source/Lib/TLibCommon/CommonDef.h
===================================================================
--- trunk/source/Lib/TLibCommon/CommonDef.h	(revision 1314)
+++ trunk/source/Lib/TLibCommon/CommonDef.h	(revision 1321)
@@ -278,4 +278,6 @@
 static const Int  MAX_NUM_VIDEO_SIGNAL_INFO =                     16 ;
 static const Int  MAX_NUM_SCALED_REF_LAYERS =     MAX_NUM_LAYERS - 1 ; 
+static const Int  MAX_NUM_PICS_RPS          =                     16 ; 
+static const Int  MAX_NUM_REF_LAYERS        =                     63 ;  
 #endif
 
@@ -367,4 +369,73 @@
 #endif
 
+#if NH_MV
+static const std::string NALU_TYPE_STR[] = {  
+    "CODED_SLICE_TRAIL_N   ",  // 0
+    "CODED_SLICE_TRAIL_R   ",  // 1
+    "CODED_SLICE_TSA_N     ",  // 2
+    "CODED_SLICE_TSA_R     ",  // 3
+    "CODED_SLICE_STSA_N    ",  // 4
+    "CODED_SLICE_STSA_R    ",  // 5
+    "CODED_SLICE_RADL_N    ",  // 6
+    "CODED_SLICE_RADL_R    ",  // 7
+    "CODED_SLICE_RASL_N    ",  // 8
+    "CODED_SLICE_RASL_R    ",  // 9
+    "RESERVED_VCL_N10      ",
+    "RESERVED_VCL_R11      ",
+    "RESERVED_VCL_N12      ",
+    "RESERVED_VCL_R13      ",
+    "RESERVED_VCL_N14      ",
+    "RESERVED_VCL_R15      ",
+    "CODED_SLICE_BLA_W_LP  ",  // 16
+    "CODED_SLICE_BLA_W_RADL",  // 17
+    "CODED_SLICE_BLA_N_LP  ",  // 18
+    "CODED_SLICE_IDR_W_RADL",  // 19
+    "CODED_SLICE_IDR_N_LP  ",  // 20
+    "CODED_SLICE_CRA       ",  // 21
+    "RESERVED_IRAP_VCL22   ",
+    "RESERVED_IRAP_VCL23   ",
+    "RESERVED_VCL24        ",
+    "RESERVED_VCL25        ",
+    "RESERVED_VCL26        ",
+    "RESERVED_VCL27        ",
+    "RESERVED_VCL28        ",
+    "RESERVED_VCL29        ",
+    "RESERVED_VCL30        ",
+    "RESERVED_VCL31        ",
+    "VPS                   ",   // 32
+    "SPS                   ",   // 33
+    "PPS                   ",   // 34
+    "ACCESS_UNIT_DELIMITER ",   // 35
+    "EOS                   ",   // 36
+    "EOB                   ",   // 37
+    "FILLER_DATA           ",   // 38
+    "PREFIX_SEI            ",   // 39
+    "SUFFIX_SEI            ",   // 40
+    "RESERVED_NVCL41       ",
+    "RESERVED_NVCL42       ",
+    "RESERVED_NVCL43       ",
+    "RESERVED_NVCL44       ",
+    "RESERVED_NVCL45       ",
+    "RESERVED_NVCL46       ",
+    "RESERVED_NVCL47       ",
+    "UNSPECIFIED_48        ",
+    "UNSPECIFIED_49        ",
+    "UNSPECIFIED_50        ",
+    "UNSPECIFIED_51        ",
+    "UNSPECIFIED_52        ",
+    "UNSPECIFIED_53        ",
+    "UNSPECIFIED_54        ",
+    "UNSPECIFIED_55        ",
+    "UNSPECIFIED_56        ",
+    "UNSPECIFIED_57        ",
+    "UNSPECIFIED_58        ",
+    "UNSPECIFIED_59        ",
+    "UNSPECIFIED_60        ",
+    "UNSPECIFIED_61        ",
+    "UNSPECIFIED_62        ",
+    "UNSPECIFIED_63        ",
+    "INVALID               "               
+  };
+#endif
 
 #if NH_3D
Index: trunk/source/Lib/TLibCommon/Debug.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/Debug.cpp	(revision 1314)
+++ trunk/source/Lib/TLibCommon/Debug.cpp	(revision 1321)
@@ -152,10 +152,10 @@
 EnvVar DebugOptionList::ForceLumaMode         ("FORCE_LUMA_MODE",   "0", "Force a particular intra direction for Luma (0-34)"                                             );
 EnvVar DebugOptionList::ForceChromaMode       ("FORCE_CHROMA_MODE", "0", "Force a particular intra direction for chroma (0-5)"                                            );
-
-#if DEBUG_STRING
-EnvVar DebugOptionList::DebugString_Structure ("DEBUG_STRUCTURE",   "3", "Produce output on chosen structure                        bit0=intra, bit1=inter");
-EnvVar DebugOptionList::DebugString_Pred      ("DEBUG_PRED",        "3", "Produce output on prediction data.                        bit0=intra, bit1=inter");
-EnvVar DebugOptionList::DebugString_Resi      ("DEBUG_RESI",        "3", "Produce output on residual data.                          bit0=intra, bit1=inter");
-EnvVar DebugOptionList::DebugString_Reco      ("DEBUG_RECO",        "3", "Produce output on reconstructed data.                     bit0=intra, bit1=inter");
+                                                                      
+#if DEBUG_STRING                                                      
+EnvVar DebugOptionList::DebugString_Structure ("DEBUG_STRUCTURE",   "0", "Produce output on chosen structure                        bit0=intra, bit1=inter");
+EnvVar DebugOptionList::DebugString_Pred      ("DEBUG_PRED",        "0", "Produce output on prediction data.                        bit0=intra, bit1=inter");
+EnvVar DebugOptionList::DebugString_Resi      ("DEBUG_RESI",        "0", "Produce output on residual data.                          bit0=intra, bit1=inter");
+EnvVar DebugOptionList::DebugString_Reco      ("DEBUG_RECO",        "0", "Produce output on reconstructed data.                     bit0=intra, bit1=inter");
 EnvVar DebugOptionList::DebugString_InvTran   ("DEBUG_INV_QT",      "0", "Produce output on inverse-quantiser and transform stages. bit0=intra, bit1=inter");
 #endif
